<?php

class AmazonSAXParser extends SAXParser {
	
	private $inError;
	private $inImage;
	public $errorMessage;
	public $asin;
	public $imageURL;
	public $formattedPrice;
	public $cartId;
	public $hmac;
	public $purchaseURL;
	
	public function startElement($parser, $name, $attributes) {
		if ($name == "Errors") {
			$this->tagName = $name;	
			$this->inError = true;
			$this->errorMessage = array();			
		}
		
		if ($name == "Message") {
			$this->tagName = $name;
		}
		
		if ($name == "SmallImage") {
			$this->tagName = $name;	
			$this->inImage = true;
		}
		
		if ($name == "URL") {
			$this->tagName = $name;	
		}
		
		if ($name == "ASIN") {
			$this->tagName = $name;
		}
		
		if ($name == "FormattedPrice") {
			$this->tagName = $name;	
		}
		
		if ($name == "CartId") {
			$this->tagName = $name;	
		}

		if ($name == "HMAC") {
			$this->tagName = $name;	
		}
		
		if ($name == "PurchaseURL") {
			$this->tagName = $name;	
		}
		
	}

	public function characterData($parser, $data) {
		if ($this->inError == true && $this->tagName == "Message") {
			array_push($this->errorMessage, $data);
		}
		
		if ($this->tagName == "ASIN") {
			$this->asin = $data;	
		}
		
		if ($this->inImage == true && $this->tagName == "URL") {
			$this->imageURL = $data;
		}
		
		if ($this->tagName == "FormattedPrice") {
			$this->formattedPrice = $data;	
		}
		
		if ($this->tagName == "CartId") {
			$this->cartId = $data;	
		}
		
		if ($this->tagName == "HMAC") {
			$this->hmac = $data;	
		}
		
		if ($this->tagName == "PurchaseURL") {
			$this->purchaseURL = $data;	
		}
	}

	public function endElement($parser, $name) {
		if ($this->tagName == "Errors") {
			$inError = false;	
		}

		if ($this->tagName == "SmallImage") {
			$inImage = false;	
		}
		
		$this->tagName = "";
	}

} 
/*
 * 
 * <Errors><Error><Code>AWS.MissingParameterValueCombination</Code><Message>Your request is missing a required parameter combination.  When IdType equals UPC, SearchIndex must be present.</Message></Error></Errors>
 */
?>