<?php

$q = $_POST['query'];
 require_once('classes/RESTParser.php');
/*****
 * Google API
 */
$params = array('key' => 'Twój klucz licensji Google',
	'q' => $_POST['query'], 
	'start' => 0,
	'maxResults' => 10,
	'filter' => true,
	'restrict' => 'countryUS',
	'safeSearch' => false,  
	'lr' => 'english',
	'ie' => 'utf-8',
	'oe' => 'utf-8'
	);

$googleClient = new SoapClient(null,
	array('location' => "http://api.google.com/search/beta2", 
			'uri' => "urn:GoogleSearch"
	)
);

try {
	$googleResults = $googleClient->__soapCall('doGoogleSearch', $params);
} catch (SoapFault $googleError) {
	echo "Błąd!<br>";
	echo "Kod błędu: " . $googleError->faultcode . "<br>";
	echo "Komunikat błędu: " .$googleError->faultstring. "<br>";
	echo "Szczegóły: " .$googleError->detail;	
}
/*****
 * Koniec Google
 */


/******
 * Początek MSN
 */
 
 	$params = array('Request' => array(
					'AppID' => 'Twój klucz MSN API',
					'Query' => $_POST['query'],
					'CultureInfo' => 'en-US',
					'SafeSearch' => 'Strict',
					'Flags' => '',
					'Location' => '',
					'Requests' => array(
							'SourceRequest' => array(
									'Source' => 'Web',
									'Offset' => 0,
									'Count' => 10,
									'ResultFields' => 'All'))));

	$msnClient = new SoapClient("http://soap.search.msn.com/webservices.asmx?wsdl");

	try {
		$msnResults = $msnClient->Search($params);
	} catch(SoapFault $msnError) {
		echo "Błąd!<br>";
		echo "Kod błędu: " . $msnError->faultcode . "<br>";
		echo "Komunikat błędu: " .$msnError->faultstring. "<br>";
		echo "Szczegóły: " . $msnError->detail;	
	}
 /**** 
  * Koniec MSN
  */
 
 /*****
  * Początek Yahoo!
  */

$params = array('appid' => 'Twój identyfikator Yahoo! App ID',
	'query' => $_POST['query'], 
	'region' => 'us',
	'type' => 'all',
	'results' => 10,
	'start' => 0,
	'format' => 'any',
	'adult_ok' => 1,
	'similiar_ok' => 0,
	'output' => 'php'
 	);

	$parser = new RESTParser();
	$t = $parser->callService($params, 'search.yahooapis.com', '/WebSearchService/V1/webSearch', 'GET');

$yahooResults = unserialize($t);
 /****
  * End Yahoo!
  */
?>
<html>
<head><title>Mieszanka wyników z różnych wyszukiwarek?</title></head>
<body>

<?php if ($googleResults) { ?>
<h1>Wyniki z Google</h1>
<table>
<tr>
<th>Tytuł</th>
<th>URL</th>
</tr>
	<?php foreach ($googleResults->resultElements as $key => $value) { ?>
		<tr>
		<td><?= $value->title ?></td>
		<td><?= $value->URL ?></td>
		</tr>
	<?php } ?>
</table>
<?php } ?>

<?php if ($msnResults) { ?>
<h1>Wyniki z MSN</h1>
<table>
<tr>
<th>Tytuł</th>
<th>URL</th>
</tr>
	<?php foreach ($msnResults->Response->Responses->SourceResponse->Results->Result as $key => $value) { ?>
		<tr>
		<td><?= $value->Title ?></td>
		<td><?= $value->Url ?></td>
		</tr>
	<?php } ?>
</table>
<?php } ?>

<?php if ($yahooResults) { ?>
<h1>Wyniki z Yahoo!</h1>
<table>
<tr>
<th>Tytuł</th>
<th>URL</th>
</tr>
	<?php foreach ($yahooResults['ResultSet']['Result'] as $key => $value) { ?>
		<tr>
		<td><?= $value['Title'] ?></td>
		<td><?= $value['Url'] ?></td>
		</tr>
	<?php } ?>
</table>
<?php } ?>
</body>
</html>